diff --git a/lib/libmt/Makefile b/lib/libmt/Makefile
index a6efe28..f60919a 100644
--- a/lib/libmt/Makefile
+++ b/lib/libmt/Makefile
@@ -6,6 +6,7 @@ SHLIBDIR?=	/lib
 SRCS=		mtlib.c
 INCS=		mtlib.h
 
+CFLAGS+=	-I${.CURDIR}
 LIBADD=		sbuf bsdxml
 
 MAN=		mt.3
diff --git a/lib/libsysdecode/Makefile b/lib/libsysdecode/Makefile
index ce89201..ba78ae4 100644
--- a/lib/libsysdecode/Makefile
+++ b/lib/libsysdecode/Makefile
@@ -9,7 +9,7 @@ SRCS=	errno.c flags.c ioctl.c signal.c syscallnames.c utrace.c
 INCS=	sysdecode.h
 
 CFLAGS+= -I${.OBJDIR}
-CFLAGS+= -I${SRCTOP}/sys
+CFLAGS+= -I${SRCTOP}/sys -I${.CURDIR}
 CFLAGS+= -I${SRCTOP}/libexec/rtld-elf
 
 MAN=	sysdecode.3 \
 
diff --git a/lib/libdpv/Makefile b/lib/libdpv/Makefile
index 280f7de..d0663b0 100644
--- a/lib/libdpv/Makefile
+++ b/lib/libdpv/Makefile
@@ -11,6 +11,7 @@ LIBADD=	dialog figpar util ncursesw
 
 SRCS=		dialog_util.c dialogrc.c dprompt.c dpv.c status.c util.c
 
-CFLAGS+=	-I${.CURDIR}
+CFLAGS+=	-I${.CURDIR} -I${.CURDIR}/../libfigpar
+LDFLAGS+=	-L${.OBJDIR}/../libfigpar
 
 .include <bsd.lib.mk>
diff --git a/lib/libcasper/libcasper/Makefile b/lib/libcasper/libcasper/Makefile
index 1064ada..32a2e66 100644
--- a/lib/libcasper/libcasper/Makefile
+++ b/lib/libcasper/libcasper/Makefile
@@ -18,6 +18,7 @@ INCS+=	libcasper_service.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../libnv
 
 MAN+=	libcasper.3
 
diff --git a/lib/libcasper/services/cap_dns/Makefile b/lib/libcasper/services/cap_dns/Makefile
index bf6bed5..baeecbe 100644
--- a/lib/libcasper/services/cap_dns/Makefile
+++ b/lib/libcasper/services/cap_dns/Makefile
@@ -14,5 +14,6 @@ INCS=	cap_dns.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../../libnv
 
 .include <bsd.lib.mk>
diff --git a/lib/libcasper/services/cap_grp/Makefile b/lib/libcasper/services/cap_grp/Makefile
index 78a860a..dfb4911 100644
--- a/lib/libcasper/services/cap_grp/Makefile
+++ b/lib/libcasper/services/cap_grp/Makefile
@@ -14,5 +14,6 @@ INCS=	cap_grp.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../../libnv
 
 .include <bsd.lib.mk>
diff --git a/lib/libcasper/services/cap_pwd/Makefile b/lib/libcasper/services/cap_pwd/Makefile
index e4df38b..64d7709 100644
--- a/lib/libcasper/services/cap_pwd/Makefile
+++ b/lib/libcasper/services/cap_pwd/Makefile
@@ -14,5 +14,6 @@ INCS=	cap_pwd.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../../libnv
 
 .include <bsd.lib.mk>
diff --git a/lib/libcasper/services/cap_random/Makefile b/lib/libcasper/services/cap_random/Makefile
index d69c160..658be9c 100644
--- a/lib/libcasper/services/cap_random/Makefile
+++ b/lib/libcasper/services/cap_random/Makefile
@@ -14,5 +14,6 @@ INCS=	cap_random.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../../libnv
 
 .include <bsd.lib.mk>
diff --git a/lib/libcasper/services/cap_sysctl/Makefile b/lib/libcasper/services/cap_sysctl/Makefile
index 2471e65..b20a342 100644
--- a/lib/libcasper/services/cap_sysctl/Makefile
+++ b/lib/libcasper/services/cap_sysctl/Makefile
@@ -14,5 +14,6 @@ INCS=	cap_sysctl.h
 LIBADD=	nv
 
 CFLAGS+=-I${.CURDIR}
+LDFLAGS+=-L${.OBJDIR}/../../../libnv
 
 .include <bsd.lib.mk>
diff --git a/lib/libc/Makefile b/lib/libc/Makefile
index 1cf73a7..f1c2bc8 100644
--- a/lib/libc/Makefile
+++ b/lib/libc/Makefile
@@ -51,6 +51,7 @@ CFLAGS+=${CANCELPOINTS_CFLAGS}
 #
 LDFLAGS+= -nodefaultlibs
 LIBADD+=	compiler_rt
+LDFLAGS+=	-L${.OBJDIR}/../libcompiler_rt
 
 .if ${MK_SSP} != "no"
 LIBADD+=	ssp_nonshared
diff --git a/lib/libcompiler_rt/Makefile b/lib/libcompiler_rt/Makefile
index 4da1166..b34297a 100644
--- a/lib/libcompiler_rt/Makefile
+++ b/lib/libcompiler_rt/Makefile
@@ -11,6 +11,7 @@ CFLAGS+=	${PICFLAG}
 CFLAGS+=	-fvisibility=hidden
 CFLAGS+=	-DVISIBILITY_HIDDEN
 CFLAGS+=	-I${SRCTOP}/contrib/libcxxrt
+LDFLAGS+=	-L${.OBJDIR}/../libc
 
 .if ${COMPILER_TYPE} == "clang"
 CWARNFLAGS.gcc_personality_v0.c+= -Wno-typedef-redefinition
diff --git a/lib/libcam/Makefile b/lib/libcam/Makefile
index 310c9a2..86a5e8c 100644
--- a/lib/libcam/Makefile
+++ b/lib/libcam/Makefile
@@ -40,6 +40,7 @@ MLINKS+=	cam.3 cam_open_device.3 \
 		${SRCTOP}/sys/cam
 
 CFLAGS+=	-I${.CURDIR} -I${SRCTOP}/sys
+LDFLAGS+=	-L${.OBJDIR}/../libsbuf
 
 SHLIB_MAJOR=	7
 
